#include "csapp.h"

void handler(int sig)  /* SIGINT handler */
{
  printf("Caught SIGINT\n");
  exit(0);
}

int main() {
  sigset_t mask;

  sigemptyset(&mask);
  sigaddset(&mask, SIGINT); 
  sigprocmask(SIG_BLOCK, &mask, NULL);
  
  /* Install SIGINT handler */
  if(signal(SIGINT, handler) == SIG_ERR)
    unix_error("signal error");

  Sleep(3);

  sigprocmask(SIG_UNBLOCK, &mask, NULL);

  Pause();

  exit(0);
}
