#include "csapp.h"

static void check_child(pid_t pid)
{
  int status;

  if (Waitpid(pid, &status, WNOHANG) == pid)
    printf("done\n");
}

int main() {
  pid_t pid;

  /* child sleeps until SIGKILL signal received
     then dies */
  if((pid = Fork()) == 0) {
    Pause();  /* wait for signal */
    printf("control never reaches here");
    exit(0);
  }

  check_child(pid);

  /* parent sends SIGKILL signal to child */
  Kill(pid, SIGKILL);

  /* (Don't write a busy loop like this in real code.) */
  while (1) {
    usleep(1);
    check_child(pid);
  }

  exit(0);
}
